#ifndef AUDIOWIDGET_H
#define AUDIOWIDGET_H

#include <QObject>
#include <QWidget>
#include <QVBoxLayout>
#include <QDialog>

#include "audiomasterwidget.h"
#include "audiolayerwidget.h"
#include "settings.h"
#include "miniaudio.h"
#include "defines.h"


class AudioWidget : public QWidget
{
    friend class libreMediaServerAudio;

    Q_OBJECT

public:

    static AudioWidget *getInstance();
    ma_engine getEngine();
    void stopEngine();
    void startEngine(int id);
    ma_device_info* pPlaybackDeviceInfos;
    ma_uint32 playbackDeviceCount;
    ma_uint32 iChosenDevice;

protected:

    void mediaLoaded(int layer, QString media );
    void volChanged(int layer, qreal vol);
    void panChanged(int layer, qreal pan);
    void pitchChanged(int layer, qreal pitch);
    void playbackChanged(int layer, Status status);
    void startEngine();

private:

    static AudioWidget *_instance;
    AudioWidget();
    QHBoxLayout *layout;
    ma_engine engines[MAX_DEVICES];
    ma_uint32 engineCount;
    ma_device devices[MAX_DEVICES];
    ma_context context;
    ma_resource_manager_config resourceManagerConfig;
    ma_resource_manager resourceManager;
    void getAllAudioDevices();
    void startDevice(int id);
    void startContext();

signals:
    
public slots:

};

#endif // AUDIOWIDGET_H
